/* Declaracoes de teclado.cc */



// Posicao a partir da qual se encontram as teclas especiais, usado para
// fazer referencia a teclas especiais. Ex: 72 + ESPECIAL -> seta para cima.
#define ESPECIAL 128

// Teclas, sem comentario - tecla convensional, detectar: codigo_da_tecla;
//         especial - tecla seguinte eh especial, detectar: codigo_da_tecla;
//         especial ou nao - codigo refere-se a 2 teclas, uma especial e
//         outra convensional que tem mesma funcao, detectar:
//         codigo_da_tecla + ESPECIAL (especial) ou codigo_da_tecla (comum).
// normal
#define T_ESC		1
// especial ou nao
#define T_SOB		72
// especial ou nao
#define T_DIR		77
// especial ou nao
#define T_DES		80
// especial ou nao
#define T_ESQ     75
// especial ou nao
#define T_HOME    71
// especial ou nao
#define T_PG_UP   73
// normal
#define T_ENTER	28
#define T_TAB		15
#define T_ESPACO	57
#define T_A			30
#define T_Z       44
#define T_ALT_E   56
#define T_CTRL_E  29
#define T_SHIFT_E 42
#define T_F1      59
#define T_F2      60
#define T_F3      61
#define T_F4      62
#define T_F5      63
// especial
#define T_ALT_D   56 + ESPECIAL
// especial
#define T_CTRL_D  29 + ESPECIAL
// normal
#define T_SHIFT_D 42



class CTeclado
{

public:

   CTeclado ( BOOL bInstalarHandler = FALSE );
   ~CTeclado ();

private:

	_go32_dpmi_seginfo m_stHandlerAntigo;    // handler de teclado original
	_go32_dpmi_seginfo m_stHandlerNovo;      // handler de teclado do programa

   BOOL m_bInstalarHandler;    // define se deve instalar o handler (deve
                               // TRUE se for a primeira instancia da classe)
   void mHandlerNovo ();
   void mHandlerNovo___ ();     // DEVE VIR SEMPRE LOGO APOS mHandlerNovo

public:

	BOOL mRetPress ( BYTE yTecla );
   BYTE mRetTeclas ( BOOL bTestaPress = TRUE);
   void mRetTecla ( BYTE yTecla, BOOL bTestaPress = TRUE );
	void mRetSoltas ();
};
